---
title: Vlans
categories: [cheatsheets]
tags: [networking]
---

# Virtual LANS (VLANs)

Vlans can splits different Hosts in the local network.

* Basically: Switches only forward Frames inbetween same vLan
* Therefore you can have multiple LANs within one Network without the need of multiple Switches and Cables

Whats Important:

* belonging of Stations
* Configuration
* Communication between the Switches
* IEEE Standards

## Normally:

1 Switch with 3 Ports, one every Port there are multiple Stations (each Port is one separated network)

## VLAN:

1 Switch with X Ports, having multiple Stations, randomly at the switch, having multiple VLANS that are port-independent

* Works over Backbones
* Works with other technologies (IP)

## Membership

Different techniques:

Split by:

* Port Numbers (Ports on a switch)
* MAC addresses (defined in the switch)
* IP Addresses (-> not really good)
* Multicast IP addresses (one IP multicast = one vlan)
* a combination of the above

## Truncation

This is for the case you have multiple VLAN Switches
-> The switches have a "Trunk Port" over which the Frames are passed from one switch to another
-> Packets are tagged with a vlan ID to identify the correct vlan membership

## Frame Tagging (IEEE 802.1q for Frame Tagging)

Another Field in the Frame for the Vlan tag:

```[TAG]  = [Ether Type][PRI][CFI][VLAN ID]```

- Ether Type: (16 Bit) to know that this is a vlan packet
- PRI: (3 Bit) Priority
- CFI: (1 Bit) almost always 0 (for compatibility with token ring)
- VLAN ID: (12 Bit) Number of the corresponding vlan


## Priorities

Quality of Service Classes:

* 0 : Best Effort (BE)
* 1 : Background (BK)
* 2 : - (not specified)
* 3 : Excellent Effort (EE)
* 4 : Controlled Load (CL)
* 5 : Video < 100ms (VI)
* 6 : Voice < 10ms (VO)
* 7 : Network Control (NC)

