---
title: Vim Notetaking Workflow
categories: [cheatsheets]
tags: [workflow]
---

# Vim Notetaking Workflow

For notetakig with vim, the plugin vim-notes is used.

* Source: [Github Repository](https://github.com/xolox/vim-notes)

_Note:_ vim-notes is using mostly markdown syntax (great for converting to html, ...)


Settings in the .vimrc:

```
let g:notes_directories = ['~/documents/todo']
let g:notes_suffix = '.note'

" use this extension to autocmd Goyo
autocmd BufAdd *.note :Goyo 90%
```

## Workflow

* To open a note use the following syntax: `vim note:thesis`
* The same works for creating a new note
    * Benefit: Can be done from any directory (all notes are stored in ~/documents/todo)
* Search all notes with: `SearchNotes xyz`
* Use it with `:Goyo 90%` for the cleaner look! 😃
* Have one file referencing all available notes (as index index.note file)
* bind it in i3 to `mod+n` and start it as floating/scratchpad window

-> Have one unique note-file for different topics. (eg. thesis, generic todo, ...)

## Rules

For Todo-Items use:

```
* TODO For todo items
* DONE For things that are already done
* XXX For important things
```

**Basic Layout:**

```
title

## General

## Notes/Misc

```

