# Cheatsheets

A collection of cheatsheets and checklists for certain security related topics.

## Overview

### Cheatsheets

* [/automotive/linbus.md](cheatsheets/automotive/linbus.md)
* [/automotive/obd2-bt.md](cheatsheets/automotive/obd2-bt.md)
* [/crypto/crypto-best-practices-checklist.md](cheatsheets/crypto/crypto-best-practices-checklist.md)
* [/crypto/crypto_cves.md](cheatsheets/crypto/crypto_cves.md)
* [/crypto/feedback-shift-registers.md](cheatsheets/crypto/feedback-shift-registers.md)
* [/crypto/openssl_commands.md](cheatsheets/crypto/openssl_commands.md)
* [/crypto/pkcs.md](cheatsheets/crypto/pkcs.md)
* [/crypto/prng.md](cheatsheets/crypto/prng.md)
* [/crypto/tls_attacks.md](cheatsheets/crypto/tls_attacks.md)
* [/datascience/data-science-at-the-commandline.md](cheatsheets/datascience/data-science-at-the-commandline.md)
* [/datascience/elasticsearch.md](cheatsheets/datascience/elasticsearch.md)
* [/misc/vim.md](cheatsheets/misc/vim.md)
* [/mobile/GSM.md](cheatsheets/mobile/GSM.md)
* [/networking/WEP.md](cheatsheets/networking/WEP.md)
* [/networking/redirecting_packets.md](cheatsheets/networking/redirecting_packets.md)
* [/networking/vlans.md](cheatsheets/networking/vlans.md)
* [/security/exploitation/formatstring.md](cheatsheets/security/exploitation/formatstring.md)
* [/security/exploitation/radare2.md](cheatsheets/security/exploitation/radare2.md)
* [/security/exploitation/shellcode.md](cheatsheets/security/exploitation/shellcode.md)
* [/security/malware/COM.md](cheatsheets/security/malware/COM.md)
* [/security/malware/anti-debugging.md](cheatsheets/security/malware/anti-debugging.md)
* [/security/malware/createmutex.md](cheatsheets/security/malware/createmutex.md)
* [/security/malware/createthread.md](cheatsheets/security/malware/createthread.md)
* [/security/malware/maliciouswindowsfunctions.md](cheatsheets/security/malware/maliciouswindowsfunctions.md)
* [/security/malware/malware_launching.md](cheatsheets/security/malware/malware_launching.md)
* [/security/malware/persistence.md](cheatsheets/security/malware/persistence.md)
* [/security/malware/services.md](cheatsheets/security/malware/services.md)
* [/security/malware/structured_exception_handling.md](cheatsheets/security/malware/structured_exception_handling.md)
* [/security/mobile/android-debugging-frida.md](cheatsheets/security/mobile/android-debugging-frida.md)
* [/security/mobile/android-remount-rw-alternative.md](cheatsheets/security/mobile/android-remount-rw-alternative.md)
* [/security/pentesting/http_security_headers.md](cheatsheets/security/pentesting/http_security_headers.md)
* [/security/pentesting/metasploit.md](cheatsheets/security/pentesting/metasploit.md)
* [/security/pentesting/recon-ng.md](cheatsheets/security/pentesting/recon-ng.md)
* [/security/pentesting/tools.md](cheatsheets/security/pentesting/tools.md)
* [/security/reversing/anti-disassembly.md](cheatsheets/security/reversing/anti-disassembly.md)
* [/security/reversing/anti-virtualmachine.md](cheatsheets/security/reversing/anti-virtualmachine.md)
* [/security/reversing/calling-conventions.md](cheatsheets/security/reversing/calling-conventions.md)
* [/security/reversing/reverse-engineering-web-assembly.md](cheatsheets/security/reversing/reverse-engineering-web-assembly.md)
* [/security/source-code-audit/debugging-java-thick-clients.md](cheatsheets/security/source-code-audit/debugging-java-thick-clients.md)
* [/security/web/php-type-juggling.md](cheatsheets/security/web/php-type-juggling.md)
* [/security/web/php-vulnerabilities.md](cheatsheets/security/web/php-vulnerabilities.md)
* [/security/web/sql-injection.md](cheatsheets/security/web/sql-injection.md)
* [/security/windows/domain-portscanning.md](cheatsheets/security/windows/domain-portscanning.md)
* [/security/windows/kerberos-attacks.md](cheatsheets/security/windows/kerberos-attacks.md)
* [/security/windows/lateral-movement.md](cheatsheets/security/windows/lateral-movement.md)
* [/security/windows/malicious-dll.md](cheatsheets/security/windows/malicious-dll.md)
* [/security/windows/mimikatz.md](cheatsheets/security/windows/mimikatz.md)
* [/security/windows/ntlm-relaying.md](cheatsheets/security/windows/ntlm-relaying.md)
* [/security/windows/powershell.md](cheatsheets/security/windows/powershell.md)
* [/security/windows/windows-LPE-schedtask.md](cheatsheets/security/windows/windows-LPE-schedtask.md)
* [/security/windows/windows-administration.md](cheatsheets/security/windows/windows-administration.md)
* [/security/windows/windows-local-privesc.md](cheatsheets/security/windows/windows-local-privesc.md)
* [/security/windows/windows-mof-files.md](cheatsheets/security/windows/windows-mof-files.md)
* [/security/windows/windows-services.md](cheatsheets/security/windows/windows-services.md)
* [/security/windows/wmic.md](cheatsheets/security/windows/wmic.md)
* [/workflow/i3-scripts.md](cheatsheets/workflow/i3-scripts.md)
* [/workflow/notetaking-workflow.md](cheatsheets/workflow/notetaking-workflow.md)

### Checklists

* [mobile/android_audit.md](checklists/mobile/android_audit.md)
